<template>
  <background class="row justify-center">
    <q-card class="col-lg-4 col-md-6 col-sm-10 col-xs-10 q-my-xl">
      <q-card-section>
        <h3>Registrace</h3>
      </q-card-section>

      <q-separator inset />

      <q-card-section>
        <q-form
          class="q-gutter-md"
          @submit="onSubmit"
        >
          <q-input
            v-model="name"
            filled
            label="Vaše jméno *"
            lazy-rules
            :rules="[
              val => val && val.length > 0 || 'Prosím zadejte jméno',
              val => val.length < 255 || 'Jméno je příliš dlouhé'
            ]"
          />
          <div class="row">
            <div class="col q-pr-sm">
              <q-input
                v-model="password"
                filled
                :type="isPwd ? 'password' : 'text'"
                label="Vaše heslo *"
                lazy-rules
                :rules="[
                  val => val && val.length > 0 || 'Prosím zadejte heslo',
                  val => val.length > 5 || 'Heslo musí mít alespoň 6 znaků',
                  val => val.length < 255 || 'Heslo je příliš dlouhé'
                ]"
              >
                <template #append>
                  <q-icon
                    :name="isPwd ? 'visibility_off' : 'visibility'"
                    class="cursor-pointer"
                    @click="isPwd = !isPwd"
                  />
                </template>
              </q-input>
            </div>
            <div class="col q-pl-sm">
              <q-input
                v-model="password2"
                filled
                :type="isPwd ? 'password' : 'text'"
                label="Vaše heslo podruhé *"
                lazy-rules
                :rules="[
                  val => val && val.length > 0 || 'Prosím zadejte heslo podruhé',
                  val => password == val || 'Hesla se musí shodovat'
                ]"
              >
                <template #append>
                  <q-icon
                    :name="isPwd ? 'visibility_off' : 'visibility'"
                    class="cursor-pointer"
                    @click="isPwd = !isPwd"
                  />
                </template>
              </q-input>
            </div>
          </div>

          <div>
            <q-btn
              label="Registrovat se"
              :disable="loading"
              type="submit"
              color="primary"
              :loading="loading"
            >
              <template #loading>
                <q-spinner-gears />
              </template>
            </q-btn>
          </div>
        </q-form>
      </q-card-section>
    </q-card>
  </background>
</template>

<script lang="ts">

import { useQuasar } from 'quasar'
import { ref } from 'vue'
import { useRouter } from 'vue-router'

import background from '@/components/Background.vue'
import useUserStore from '@/store/userStore'

export default {
  name: 'Register',
  components: {
    background
  },

  setup (): any {
    const $q = useQuasar()
    const user = useUserStore()
    const router = useRouter()

    const name = ref('')
    const password = ref('')
    const password2 = ref('')
    const isPwd = ref(true)
    const loading = ref(false)

    return {
      name,
      password,
      password2,
      isPwd,
      loading,

      onSubmit () {
        loading.value = true

        user.register({
          name: name.value,
          password: password.value
        })
          .then(
            () => {
              $q.notify({
                type: 'positive',
                message: 'Byl jste úspěšně registrován, přihlašte se prosím'
              })

              router.push({ name: 'signIn' })
            })
          .finally(
            () => {
              loading.value = false
            }
          )
      }

    }
  }
}

</script>
